// $Id: test_person.c,v 1.2 2017/04/10 00:29:35 leavens Exp leavens $
// Compile with:
// gcc tap.c testing_io.c person.c test_person.c -o test_person

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "testing_io.h"
#include "person.h"

static int test_read_person() {
    for (int i = 0; i < 7; i++) {
	person p = read_person("first name? ",
				 "last name? ");
	if (p == NULL) {
	    continue;
	}
	printf("read person %d is: \"%s\"\n", i, person_to_string(p));
    }
    return EXIT_SUCCESS;
}

int main() {
    plan(13);
    person ada = make_person("Ada", "Lovelace");
    ok(ada != NULL, "made ada successfully");
    if (ada != NULL) {
	ok(strcmp(ada->first_name, "Ada") == 0,
	   "strcmp(ada->first_name, \"Ada\") == 0");
	ok(strcmp(ada->last_name, "Lovelace") == 0,
	   "strcmp(ada->last_name, \"Lovelace\") == 0");
	ok(strcmp(person_to_string(ada), "Ada Lovelace") == 0,
	   "strcmp(person_to_string(ada), \"Ada Lovelace\") == 0");
    }
    
    person alan = make_person("Alan", "Turing");
    ok(alan != NULL, "made alan successfullly");
    if (alan != NULL) {
	ok(strcmp(alan->first_name, "Alan") == 0,
	   "strcmp(alan->first_name, \"Alan\") == 0");
	ok(strcmp(alan->last_name, "Turing") == 0,
	   "strcmp(alan->last_name, \"Turing\") == 0");
	ok(strcmp(person_to_string(alan), "Alan Turing") == 0,
	   "strcmp(person_to_string(alan), \"Alan Turing\") == 0");
    }

    if (ada != NULL && alan != NULL) {
	ok(equal_person(ada, ada), "equal_us_phone(ada, ada)");
	ok(equal_person(alan, alan), "equal_us_phone(alan, alan)");
	ok(!equal_person(ada, alan), "!equal_us_phone(ada, alan)");
	ok(!equal_person(alan, ada), "!equal_us_phone(alan, ada)");
    }
    
    testproc(test_read_person, "test_person1");
    
    return exit_status();
}
